// KEdit.cpp: CKEdit NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "KEdit.h"
#include "util.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CKEdit::CKEdit()
{
	m_bLocked = false;

	m_hFont=NULL;
	m_hBg=NULL;
	m_pFont=NULL;

	m_pUndo = m_pRedo = NULL;

	m_pStart=m_pTop=NULL;

	m_DefaultFont.SetUpFont( 14,"FixedSys",4,RGB(0,0,0),RGB(255,255,255),RGB(0,0,200),RGB(0,200,0),RGB(180,130,255) );
}

CKEdit::~CKEdit()
{
	if( m_hFont!=NULL )	DeleteObject(m_hFont);
	if( m_hBg!=NULL )	DeleteObject(m_hBg);

	CKEditLine* p = m_pStart;
	CKEditLine* p2;
	while( p!=NULL )
	{
		p2 = p->GetNext();
		delete p;
		p = p2;
	}

	Compact();
}

void CKEdit::CreateWnd( HWND hP,HINSTANCE hI )
{
	m_hParent = hP;

	WNDCLASS wc;
	wc.style			= CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc		= (WNDPROC)EditWndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= hI;
	wc.hIcon			= 0;
	wc.hCursor			= LoadCursor(NULL, IDC_IBEAM);
	wc.hbrBackground	= NULL;
	wc.lpszMenuName		= NULL;
	wc.lpszClassName	= "K.INABA's EditCtrl";
	RegisterClass( &wc );

	m_hWnd = CreateWindowEx(
				WS_EX_CLIENTEDGE,
				wc.lpszClassName,
				"Edit",
				WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_HSCROLL,
				0, 0, 0, 0,
				m_hParent, NULL, hI , this);

	UpdateWindow(m_hWnd);
}

LRESULT CALLBACK CKEdit::EditWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	CKEdit* pEdit = (CKEdit*)GetWindowLong( hWnd , GWL_USERDATA );
	static bool bCaptured = false;

	switch( msg )
	{
	case WM_SIZE:		pEdit->Resize( LOWORD(lParam),HIWORD(lParam) );	break;
	case WM_SETFOCUS:	pEdit->Activate(true);	break;
	case WM_KILLFOCUS:	pEdit->Activate(false);	break;
	case WM_CREATE:
		{
			CREATESTRUCT* st = (CREATESTRUCT*)lParam;
			SetWindowLong( hWnd , GWL_USERDATA , (long)(st->lpCreateParams) );
			pEdit = (CKEdit*)(st->lpCreateParams);
			pEdit->m_hWnd = hWnd;
			pEdit->ClearAll();
			pEdit->Resize( st->cx,st->cy );
		}
		break;
	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint( hWnd,&ps );
			pEdit->Draw( &ps );
			EndPaint( hWnd,&ps );
		}
		break;
	case WM_HSCROLL:
		switch( LOWORD(wParam) )
		{
		case SB_LINELEFT:	pEdit->HScroll(-1);		break;
		case SB_LINERIGHT:	pEdit->HScroll(1);		break;
		case SB_PAGELEFT:	pEdit->HScroll(-pEdit->m_WndSize.cx/(pEdit->m_pFont->Size.cx));		break;
		case SB_PAGERIGHT:	pEdit->HScroll(pEdit->m_WndSize.cx/(pEdit->m_pFont->Size.cx));	break;
		case SB_THUMBTRACK:
			if( pEdit->m_TxtSize.cx < 65535 )
				pEdit->HScroll( HIWORD(wParam)-pEdit->m_Ori.x );
			else
			{
				SCROLLINFO si;	si.cbSize = sizeof(si);	si.fMask = SIF_TRACKPOS;
				GetScrollInfo( pEdit->GetHwnd(),SB_HORZ,&si);
				pEdit->HScroll( si.nTrackPos-pEdit->m_Ori.x );
			}
			break;
		}
		break;
	case WM_VSCROLL:
		switch( LOWORD(wParam) )
		{
		case SB_LINEDOWN:	pEdit->VScroll(1);		break;
		case SB_LINEUP:		pEdit->VScroll(-1);		break;
		case SB_PAGEDOWN:	pEdit->VScroll(pEdit->m_WndSize.cy/(pEdit->m_pFont->Size.cy));	break;
		case SB_PAGEUP:		pEdit->VScroll(-pEdit->m_WndSize.cy/(pEdit->m_pFont->Size.cy));	break;
		case SB_THUMBTRACK:
			if( pEdit->m_TxtSize.cy < 65535 )
				pEdit->VScroll( HIWORD(wParam)-pEdit->m_Ori.y );
			else
			{
				SCROLLINFO si;	si.cbSize = sizeof(si);	si.fMask = SIF_TRACKPOS;
				GetScrollInfo( pEdit->GetHwnd(),SB_VERT,&si);
				pEdit->VScroll( si.nTrackPos-pEdit->m_Ori.y );
			}
			break;
		}
		break;
/*	case 0x020A:
		switch( LOWORD(wParam) )
		{
		case MK_CONTROL:
		case MK_SHIFT:	break;
		default:	pEdit->VScroll( ((short)HIWORD(wParam))/40 );	break;
		}
		break;
*/	case WM_IME_COMPOSITION:
		pEdit->ScrollCaretIn();
		return DefWindowProc( hWnd, msg, wParam, lParam );
	case WM_IME_CHAR:
		{
			pEdit->ScrollCaretIn();
			char str[2] = { (char)(wParam>>8),(char)(wParam&0xff) };
			if( str[0]=='\0' )	pEdit->AddUndo( pEdit->InputStr( str+1,1 ) );
			else				pEdit->AddUndo( pEdit->InputStr( str,2 ) );

		}
		break;
	case WM_CHAR:
		{
			pEdit->ScrollCaretIn();
			char c = (char)wParam;
			if( 0x20<=c && c<=0x7E || c=='\r' || c=='\n' || c=='\t' || 0xA0<=c && c<=0xDF )
				pEdit->AddUndo( pEdit->InputStr( &c,1 ) );
		}
		break;
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_HOME:	pEdit->Move( -(1<<30),0,true,(GetKeyState(VK_SHIFT)>>15)!=0 );	break;
		case VK_END:	pEdit->Move( (1<<25),0,false,(GetKeyState(VK_SHIFT)>>15)!=0 );	break;
		case VK_RIGHT:	pEdit->Move( 1,0,true,(GetKeyState(VK_SHIFT)>>15)!=0 );			break;
		case VK_LEFT:	pEdit->Move( -1,0,false,(GetKeyState(VK_SHIFT)>>15)!=0 );		break;
		case VK_UP:		pEdit->Move( 0,-1,false,(GetKeyState(VK_SHIFT)>>15)!=0 );		break;
		case VK_DOWN:	pEdit->Move( 0,1,false,(GetKeyState(VK_SHIFT)>>15)!=0 );		break;
		case VK_NEXT:
			pEdit->Move( 0,pEdit->m_WndSize.cy/pEdit->GetFont()->Size.cy,false,(GetKeyState(VK_SHIFT)>>15)!=0 );
			break;
		case VK_PRIOR:
			pEdit->Move( 0,-pEdit->m_WndSize.cy/pEdit->GetFont()->Size.cy,false,(GetKeyState(VK_SHIFT)>>15)!=0 );
			break;
		case VK_DELETE:	pEdit->AddUndo( pEdit->Del() );			break;
		case VK_BACK:	pEdit->AddUndo( pEdit->BackSpace() );	break;
		default:
			return DefWindowProc( hWnd, msg, wParam, lParam );
		}
		break;
	case WM_LBUTTONDOWN:
		pEdit->MoveTo( pEdit->m_Ori.x+(LOWORD(lParam)+pEdit->GetFont()->Size.cx/2)/pEdit->GetFont()->Size.cx,
					pEdit->m_Ori.y+HIWORD(lParam)/pEdit->GetFont()->Size.cy,false,(wParam&MK_SHIFT)!=0 );
		SetCapture(hWnd);
		bCaptured = true;
		break;
	case WM_LBUTTONUP:
		bCaptured = false;
		ReleaseCapture();
		break;
	case WM_LBUTTONDBLCLK:
		break;
	case WM_MOUSEMOVE:
		if( !bCaptured )
			break;
		pEdit->MoveTo( pEdit->m_Ori.x+((short)LOWORD(lParam)+pEdit->GetFont()->Size.cx/2)/pEdit->GetFont()->Size.cx,
					pEdit->m_Ori.y+(short)HIWORD(lParam)/pEdit->GetFont()->Size.cy,false,true );
		break;
	default:	return DefWindowProc(hWnd,msg,wParam,lParam);
	}
	return 0L;
}

void CKEdit::Compact()
{
	CKEditLine *p=m_pStart;
	while( p!=NULL )
	{
		p->ReAlloc();
		p = p->GetNext();
	}

	CUnReDo *d,*d2;
	d=m_pUndo;
	while( d!=NULL )
	{
		d2 = d->m_pNext;
		delete d;
		d = d2;
	}
	d=m_pRedo;
	while( d!=NULL )
	{
		d2 = d->m_pNext;
		delete d;
		d = d2;
	}
	m_pUndo = m_pRedo = NULL;
}

void CKEdit::Draw( PAINTSTRUCT* ps )
{
	int oldBkMd = SetBkMode(ps->hdc,TRANSPARENT);
	COLORREF oldTC = GetTextColor(ps->hdc);
	HFONT oldFont = (HFONT)SelectObject(ps->hdc,m_hFont);
	if( ps->fErase )
		FillRect(ps->hdc,&ps->rcPaint,m_hBg);

	CKEditLine *p=m_pTop;
	RECT rc={ -(m_Ori.x*m_pFont->Size.cx), 0, ps->rcPaint.right , ps->rcPaint.bottom };

	POINT st = m_Cur,se=m_Sel;
	bool bS = true;
	if( m_Sel.y==m_Cur.y && m_Sel.x==m_Cur.x )
		bS = false;
	else
	{
		if( m_Sel.y<m_Cur.y )
			st = m_Sel,se = m_Cur;
		else if( m_Sel.y==m_Cur.y && m_Sel.x<m_Cur.x )
			st = m_Sel,se = m_Cur;
		st.x-=m_Ori.x;
		se.x-=m_Ori.x;
		st.y-=m_Ori.y;
		se.y-=m_Ori.y;
	}

	int y=0;

/**/while( m_bLocked );m_bLocked=true;
	while( p!=NULL )
	{
		p->Draw( ps->hdc,m_pFont,&rc );

		if( bS && st.y<=y && y<=se.y )
		{
			int ss=-m_Ori.x,sf=p->m_Width+(p->GetNext()!=NULL?1:0)-m_Ori.x;
			if( st.y==y )	ss = st.x;
			if( se.y==y )	sf = se.x;
			RECT rt={ ss*GetFont()->Size.cx , rc.top ,
					  sf*GetFont()->Size.cx , rc.top+GetFont()->Size.cy-1 };
			rt.left=rt.left>0?rt.left:0;
			rt.right=rt.right<m_WndSize.cx?rt.right:m_WndSize.cx;
			if( ss<sf && rt.right>=0 && rt.left<m_WndSize.cx )
				InvertRect(ps->hdc,&rt);
		}
		y++;

		rc.top += m_pFont->Size.cy;
		if( rc.top>rc.bottom )	break;
		p=p->GetNext();
	}
/**/m_bLocked=false;

	SetTextColor(ps->hdc,oldTC);
	SetBkMode(ps->hdc,oldBkMd);
	SelectObject(ps->hdc,oldFont);
}

void CKEdit::Resize( int cx,int cy )
{
//	m_WndSize.cx = cx - GetSystemMetrics(SM_CXVSCROLL);
//	m_WndSize.cy = cy - GetSystemMetrics(SM_CYHSCROLL);
	m_WndSize.cx = cx;
	m_WndSize.cy = cy;
	SetScrollSize(false);
	InvalidateRect(m_hWnd,NULL,TRUE);
}

void CKEdit::Activate(bool b)
{
	if( b )
	{
		m_Caret.Create(m_hWnd,m_pFont->Size.cy);
		m_Caret.SetPos( (m_Cur.x-m_Ori.x)*m_pFont->Size.cx,(m_Cur.y-m_Ori.y)*m_pFont->Size.cy );
		m_Caret.SetFont(&m_pFont->Info);
	}
	else
		m_Caret.Destroy();
}

void CKEdit::ClearAll()
{
	CKEditLine* p = m_pStart;
	CKEditLine* p2;
	while( p!=NULL )
	{
		p2 = p->GetNext();
		delete p;
		p = p2;
	}

	CUnReDo *d,*d2;
	d=m_pUndo;
	while( d!=NULL )
	{
		d2 = d->m_pNext;
		delete d;
		d = d2;
	}
	d=m_pRedo;
	while( d!=NULL )
	{
		d2 = d->m_pNext;
		delete d;
		d = d2;
	}
	m_pUndo = m_pRedo = NULL;

	if( m_pFont==NULL )
		ChangeFont(&m_DefaultFont);

	m_pStart = new CKEditLine;
	m_Ori.x=m_Ori.y=0;
	m_pTop = m_pStart;
	m_VirtX=m_Sel.x=m_Sel.y=m_Cur.x=m_Cur.y=0;
	m_Caret.SetPos( (m_Cur.x-m_Ori.x)*m_pFont->Size.cx,(m_Cur.y-m_Ori.y)*m_pFont->Size.cy );

	SetScrollSize(true);
	Activate(true);
	InvalidateRect(m_hWnd,NULL,TRUE);

	SendMessage(m_hParent,KEM_CLEARED,0,0);
}

void CKEdit::ChangeFont( CKEditFont* pF )
{
	m_pFont=pF;
	if( m_hWnd!=NULL )
	{
		if( m_hFont!=NULL )	DeleteObject(m_hFont);
		m_hFont = CreateFontIndirect(&pF->Info);
		m_Caret.SetFont(&pF->Info);

		HDC hdc = GetDC(m_hWnd);
		HFONT tmpF = (HFONT)SelectObject( hdc,m_hFont );
		TEXTMETRIC tm;
		GetTextMetrics(hdc,&tm);
		SelectObject(hdc,tmpF);
		ReleaseDC( m_hWnd,hdc );

		m_pFont->Size.cx = tm.tmHeight/2-1;
		m_pFont->Size.cy = (tm.tmHeight+tm.tmExternalLeading);

		if( m_hBg!=NULL )	DeleteObject(m_hBg);
		m_hBg = CreateSolidBrush(pF->Bg);
	}
}

void CKEdit::HScroll(int dif)
{
	if( dif==0 )return;
	SCROLLINFO si;
	si.cbSize = sizeof(si);
	si.fMask = SIF_RANGE|SIF_PAGE;
	GetScrollInfo(m_hWnd,SB_HORZ,&si);

	int i;
	if( m_Ori.x+dif < 0 )
	{
		i = -m_Ori.x;
		m_Ori.x=0;
	}
	else if( m_Ori.x+dif > si.nMax-(int)si.nPage+1 )// ̕ӂ͍DȂ
	{
		i = si.nMax-si.nPage+1-m_Ori.x;
		m_Ori.x=si.nMax-si.nPage+1;
	}
	else
	{
		i=dif;
		m_Ori.x += dif;
	}

	SetScrollPos(m_hWnd,SB_HORZ,m_Ori.x,TRUE);
	RECT up;
	ScrollWindowEx(m_hWnd,-i*m_pFont->Size.cx,0,NULL,NULL,NULL,&up,0);
	m_Caret.SetPos( (m_Cur.x-m_Ori.x)*m_pFont->Size.cx,
					(m_Cur.y-m_Ori.y)*m_pFont->Size.cy );
	InvalidateRect(m_hWnd,&up,TRUE);
}

void CKEdit::VScroll(int dif)
{
	if( dif==0 )return;
	int i=0;
	if( dif>0 )
	{
		for( ; i!=dif; i++ )
		{
			if( m_pTop->GetNext()==NULL )	break;
			m_pTop = m_pTop->GetNext();
		}
	}
	else
	{
		for( ; i!=dif; i-- )
		{
			if( m_pTop->GetPrev()==NULL )	break;
			m_pTop = m_pTop->GetPrev();
		}
	}

	m_Ori.y += i;
	SetScrollPos(m_hWnd,SB_VERT,m_Ori.y,TRUE);
	RECT up;
	ScrollWindowEx(m_hWnd,0,-i*m_pFont->Size.cy,NULL,NULL,NULL,&up,0);
	m_Caret.SetPos( (m_Cur.x-m_Ori.x)*m_pFont->Size.cx,(m_Cur.y-m_Ori.y)*m_pFont->Size.cy );
	InvalidateRect(m_hWnd,&up,TRUE);
}

void CKEdit::ScrollCaretIn()
{
	if( m_Cur.x<m_Ori.x )
		HScroll(m_Cur.x-m_Ori.x);
	else if( m_Ori.x+m_WndSize.cx/m_pFont->Size.cx < m_Cur.x )
//		HScroll(m_Cur.x-(m_Ori.x+m_WndSize.cx/m_pFont->Size.cx/2) );
		HScroll(m_Cur.x-(m_Ori.x+m_WndSize.cx/m_pFont->Size.cx)+1 );

	if( m_Cur.y<m_Ori.y )
		VScroll(m_Cur.y-m_Ori.y);
	else if( m_Ori.y+m_WndSize.cy/m_pFont->Size.cy-1 < m_Cur.y )
		VScroll(m_Cur.y-(m_Ori.y+m_WndSize.cy/m_pFont->Size.cy-1) );
}

void CKEdit::SetScrollSize(bool bCalc)
{
	SCROLLINFO si;
	si.cbSize=sizeof(SCROLLINFO);
	si.fMask = SIF_PAGE | SIF_POS | SIF_RANGE | SIF_DISABLENOSCROLL;
	si.nMin=0;

	if( bCalc )
	{
		int lines = 0;
		int top = 0;
		int width = 0;
		for( CKEditLine* p=m_pStart; p!=NULL; p=p->GetNext() )
		{
			if( p->m_Width>width )
				width = p->m_Width;
			if( p==m_pTop )
				top = lines;
			lines++;
		}
		m_TxtSize.cy = lines;
		m_TxtSize.cx=width;
		m_Ori.y=top;
	}

	// Vert /////////
	si.nMax=m_TxtSize.cy+m_WndSize.cy/(m_pFont->Size.cy)-2;
	si.nPage=m_WndSize.cy/(m_pFont->Size.cy);
	si.nPos=m_Ori.y;
	SetScrollInfo(m_hWnd,SB_VERT,&si,TRUE);
	// Horz /////////
	si.nMax=m_TxtSize.cx;
	si.nPage=m_WndSize.cx/(m_pFont->Size.cx);
	si.nPos=m_Ori.x;
	SetScrollInfo(m_hWnd,SB_HORZ,&si,TRUE);
}

void CKEdit::LoadAtEnd( CKEditLine* p )
{
	CKEditLine* pEnd = m_pTop;
	while( pEnd->GetNext()!=NULL )pEnd=pEnd->GetNext();

	POINT fr = { 0,m_TxtSize.cy-1 };

	p->InsertStr(0,pEnd->buf,pEnd->len,m_pFont);
	if( pEnd==m_pTop )
		m_pTop = p;

	if( pEnd==m_pStart )
		m_pStart = p;
	else
	{
		p->m_pPrev = pEnd->GetPrev();
		pEnd->GetPrev()->m_pNext = p;
	}
	delete pEnd;

	SetScrollSize(true);

	ReDrawAfter( fr );
}

CKEditLine* CKEdit::GetBuffer(int PosY)
{
	CKEditLine* p = m_pTop;
	int y=m_Ori.y;
	if( PosY<m_Ori.y )
	{
		while( p!=NULL && y!=PosY )
		{
			p=p->GetPrev();
			y--;
		}
	}
	else
	{
		while( p!=NULL && y!=PosY )
		{
			p=p->GetNext();
			y++;
		}
	}
	return p;
}

void CKEdit::ReDrawAfter( POINT from )
{
	RECT rc;
	rc.left = (-m_Ori.x)*GetFont()->Size.cx;
	rc.top  = (from.y-m_Ori.y)*GetFont()->Size.cy;
	rc.right = m_WndSize.cx;
	rc.bottom = m_WndSize.cy;

	if( rc.top<m_WndSize.cy&&rc.left<m_WndSize.cx )
	{
		rc.left = rc.left>0?rc.left:0;
		rc.top = rc.top>0?rc.top:0;
		InvalidateRect(m_hWnd,&rc,TRUE);
	}
}

void CKEdit::ReDrawLine( POINT from )
{
	RECT rc={from.x,from.y,0,from.y+1};

	OffsetRect( &rc,-m_Ori.x,-m_Ori.y );
	rc.left *= GetFont()->Size.cx;
	rc.top *= GetFont()->Size.cy;
	rc.bottom *= GetFont()->Size.cy;

	if( rc.top<m_WndSize.cy&&rc.left<m_WndSize.cx )
	{
		rc.left = rc.left>0?rc.left:0;
		rc.top = rc.top>0?rc.top:0;
		rc.right = m_WndSize.cx;
		rc.bottom = rc.bottom>m_WndSize.cy?m_WndSize.cy:rc.bottom;
		InvalidateRect(m_hWnd,&rc,TRUE);
	}
}

void CKEdit::ReDraw(POINT from,POINT to)
{
	RECT rc={0,0,m_TxtSize.cx+5,0};
	if( from.y==to.y )
	{
		rc.left = rc.right = from.x;
		rc.top = from.y;
		rc.bottom = from.y+1;
		if( from.x<to.x ) rc.right = to.x;
		else rc.left = to.x;
	}
	else
	{
		if( from.y>to.y )
		{
			rc.top = to.y;
			rc.bottom = from.y+1;
		}
		else
		{
			rc.top = from.y;
			rc.bottom = to.y+1;
		}
	}

	OffsetRect( &rc,-m_Ori.x,-m_Ori.y );
	rc.left *= GetFont()->Size.cx;
	rc.right *= GetFont()->Size.cx;
	rc.top *= GetFont()->Size.cy;
	rc.bottom *= GetFont()->Size.cy;

	if( rc.top<m_WndSize.cy&&rc.left<m_WndSize.cx )
	{
		rc.left = rc.left>0?rc.left:0;
		rc.top = rc.top>0?rc.top:0;
		rc.right = rc.right>m_WndSize.cx?m_WndSize.cx:rc.right;
		rc.bottom = rc.bottom>m_WndSize.cy?m_WndSize.cy:rc.bottom;
		InvalidateRect(m_hWnd,&rc,TRUE);
	}
}

void CKEdit::Move( int dx,int dy,bool bRight,bool bSelect )
{
	if( !bSelect && (m_Cur.x!=m_Sel.x||m_Cur.y!=m_Sel.y)  )
		ReDraw(m_Cur,m_Sel);

	CKEditLine* c = GetBuffer(m_Cur.y);
	if( c==NULL )
		return;
	int rdy=0,rdx=0;
	if( dy<0 )
	{
		for( ; rdy!=dy; rdy-- )
		{
			if( c->GetPrev()==NULL )	break;
			c=c->GetPrev();
		}
	}
	else if( dy>0 )
	{
		for( ; rdy!=dy; rdy++ )
		{
			if( c->GetNext()==NULL )	break;
			c=c->GetNext();
		}
	}
	int rx = c->Pos2Address(m_Cur.x+dx,bRight,GetFont());
	if( rx!=-1 )
		rdx = c->Address2Pos( rx,GetFont() )-m_Cur.x;
	else
	{
		if( dx>0 )
		{
			if( c->GetNext()==NULL )	rdx = c->m_Width-m_Cur.x;
			else						rdx = -m_Cur.x,rdy++;
		}
		else
		{
			if( c->GetPrev()==NULL )	rdx = -m_Cur.x;
			else						rdx = c->GetPrev()->m_Width-m_Cur.x,rdy--;
		}
	}

	if( bSelect )
	{
		POINT pt={m_Cur.x+rdx,m_Cur.y+rdy};
		ReDraw(m_Cur,pt);
	}
	m_Cur.x+=rdx;
	m_Cur.y+=rdy;

	if( !bSelect )
		m_Sel = m_Cur;

	m_Caret.SetPos( (m_Cur.x-m_Ori.x)*GetFont()->Size.cx,(m_Cur.y-m_Ori.y)*GetFont()->Size.cy );
	ScrollCaretIn();

	SendMessage(m_hParent,KEM_CURSORMOVE,(WPARAM)&m_Cur,(LPARAM)&m_Sel);
}

void CKEdit::Copy()
{
	if( m_Sel.y==m_Cur.y && m_Sel.x==m_Cur.x )	return;

	int length = GetSelByte();
	HGLOBAL h = GlobalAlloc(GMEM_MOVEABLE,length+1);
	char* p = (char*)GlobalLock(h);
	GetSel(p);
	p[length]='\0';
	GlobalUnlock(h);

	if( !OpenClipboard(m_hWnd) )return;

	EmptyClipboard();
	SetClipboardData(CF_TEXT,h);

	CloseClipboard();
}

void CKEdit::Delete()
{
	AddUndo( DeleteSel() );
}

void CKEdit::Cut()
{
	Copy();
	AddUndo( DeleteSel() );
}

void CKEdit::Paste()
{
	if( !OpenClipboard(m_hWnd) )return;

	HANDLE h = GetClipboardData(CF_TEXT);
	if( h==NULL )
	{
		CloseClipboard();
		return;
	}

	char* p = (char*)GlobalLock(h);
	GlobalUnlock(h);

	AddUndo( InputStr(p,strlen(p)) );

	CloseClipboard();
}

void CKEdit::Undo()
{
	if( m_pUndo==NULL )
		return;

	CUnReDo *p ,*u = m_pUndo;
	if( m_pUndo->m_bInput )
	{
		MoveTo( m_pUndo->m_Cur.x,m_pUndo->m_Cur.y,false,false );
		p = InputStr( m_pUndo->buf,m_pUndo->len );
	}
	else
	{
		MoveTo( m_pUndo->m_Cur.x,m_pUndo->m_Cur.y,false,false );
		MoveTo( m_pUndo->m_Sel.x,m_pUndo->m_Sel.y,false,true );
		p = DeleteSel();
	}
	m_pUndo = m_pUndo->m_pNext;
	delete u;
	p->m_pNext = m_pRedo;
	m_pRedo = p;
}

void CKEdit::Redo()
{
	if( m_pRedo==NULL )
		return;

	CUnReDo *p ,*r = m_pRedo;
	if( m_pRedo->m_bInput )
	{
		MoveTo( m_pRedo->m_Cur.x,m_pRedo->m_Cur.y,false,false );
		p = InputStr( m_pRedo->buf,m_pRedo->len );
	}
	else
	{
		MoveTo( m_pRedo->m_Cur.x,m_pRedo->m_Cur.y,false,false );
		MoveTo( m_pRedo->m_Sel.x,m_pRedo->m_Sel.y,false,true );
		p = DeleteSel();
	}
	m_pRedo = m_pRedo->m_pNext;
	delete r;
	p->m_pNext = m_pUndo;
	m_pUndo = p;
}

int CKEdit::GetSelByte()
{
	int sum=0;
	if( m_Sel.y==m_Cur.y && m_Sel.x==m_Cur.x )
		return sum;

	POINT st = m_Cur,se=m_Sel;
	if( m_Sel.y<m_Cur.y )							st = m_Sel,se = m_Cur;
	else if( m_Sel.y==m_Cur.y && m_Sel.x<m_Cur.x )	st = m_Sel,se = m_Cur;

	CKEditLine* p = GetBuffer(st.y);
	CKEditLine* pe = GetBuffer(se.y);

	if( p==pe )
		sum = pe->Pos2Address(se.x,false,GetFont()) - p->Pos2Address(st.x,false,GetFont());
	else
	{
		sum += p->len - p->Pos2Address(st.x,false,GetFont()) + 2;//CRLF
		p=p->GetNext();
		while( p!=pe )
		{
			sum += p->len + 2;//CRLF
			p=p->GetNext();
		}
		sum += p->Pos2Address(se.x,false,GetFont());
	}

	return sum;
}

void CKEdit::GetSel(char* pBuf)
{
	if( m_Sel.y==m_Cur.y && m_Sel.x==m_Cur.x )	return;

	POINT st = m_Cur,se=m_Sel;
	if( m_Sel.y<m_Cur.y )							st = m_Sel,se = m_Cur;
	else if( m_Sel.y==m_Cur.y && m_Sel.x<m_Cur.x )	st = m_Sel,se = m_Cur;

/**/while( m_bLocked );m_bLocked=true;

	CKEditLine* p = GetBuffer(st.y);
	CKEditLine* pe = GetBuffer(se.y);

	int a=p->Pos2Address(st.x,false,GetFont());
	int c=pe->Pos2Address(se.x,false,GetFont());

	if( p==pe )
	{
		bool b = (m_TxtSize.cx==p->m_Width);
		CopyMemory( pBuf,&p->buf[a],c-a );
		pBuf += c-a;
	}
	else
	{
		CopyMemory( pBuf,&p->buf[a],p->len-a );
		pBuf += p->len-a;
		pBuf[0]='\r',pBuf[1]='\n',pBuf+=2;

		p=p->GetNext();
		while( p!=pe )
		{
			CopyMemory( pBuf,p->buf,p->len );
			pBuf += p->len;
			pBuf[0]='\r',pBuf[1]='\n',pBuf+=2;
			p=p->GetNext();
		}

		CopyMemory( pBuf,p->buf,c );
		pBuf += c;
	}

/**/m_bLocked=false;
}

CUnReDo* CKEdit::DeleteSel()
{
	if( m_Sel.y==m_Cur.y && m_Sel.x==m_Cur.x )	return NULL;

	CUnReDo* u = new CUnReDo;
	u->m_bInput = true;
	u->len = GetSelByte();
	u->buf = new char[u->len+1];
	GetSel(u->buf);

	POINT st = m_Cur,se=m_Sel;
	if( m_Sel.y<m_Cur.y )							st = m_Sel,se = m_Cur;
	else if( m_Sel.y==m_Cur.y && m_Sel.x<m_Cur.x )	st = m_Sel,se = m_Cur;

	MoveTo(st.x,st.y,false,false);

/**/while( m_bLocked );m_bLocked=true;

	CKEditLine* p = GetBuffer(st.y);
	CKEditLine* pe = GetBuffer(se.y);

	if( p==pe )
	{
		bool b = (m_TxtSize.cx==p->m_Width);
		p->Remove( p->Pos2Address(st.x,false,GetFont()) , pe->Pos2Address(se.x,false,GetFont()) , GetFont() );

		SetScrollSize(b);
		ReDrawLine(m_Cur);
	}
	else
	{
		int a=p->Pos2Address(st.x,false,GetFont());
		int c=pe->Pos2Address(se.x,false,GetFont());
		int m = p->m_Width;
		p->Remove( a,p->len,GetFont() );
		p->InsertStr( a, &pe->buf[c] , pe->len-c , GetFont() );
		bool b = (m_TxtSize.cx==p->m_Width) || (m>p->m_Width);

		CKEditLine *p2=p->GetNext(),*p3;
		p->m_pNext = pe->GetNext();
		if( pe->GetNext()!=NULL )
			pe->GetNext()->m_pPrev=p;
/*
		// delete p2  pe 폜񂾂GetNextł킯...悭
		// ܂ł̃R[hŕ\ʂȂ...
		// Ȃ̂߂ɎcĂB(00/05/29)

		while( p2!=pe->GetNext() )
		{
			m_TxtSize.cy--;
			if( m_TxtSize.cx==p2->m_Width )
				b=true;
			p3=p2->GetNext();
			delete p2;
			p2=p3;
		}
*/
		while( p2!=pe )
		{
			m_TxtSize.cy--;
			if( m_TxtSize.cx==p2->m_Width )
				b=true;
			p3=p2->GetNext();
			delete p2;
			p2=p3;
		}{
			m_TxtSize.cy--;
			if( m_TxtSize.cx==p2->m_Width )
				b=true;
			delete p2;
		}

		SetScrollSize(b);
		ReDrawAfter(m_Cur);
	}

/**/m_bLocked=false;

	SendMessage(m_hParent,KEM_CHANGED,0,0);
	u->m_Cur = m_Cur;
	return u;
}

CUnReDo* CKEdit::Del()
{
	if( GetSelByte()!=0 )
		return DeleteSel();

	CUnReDo* u = new CUnReDo;
	u->m_bInput = true;
	u->m_Cur = m_Cur;
	u->buf = new char[2];
	u->len=2;

/**/while( m_bLocked );m_bLocked=true;

	bool bNoChange = false;
	CKEditLine* p = GetBuffer(m_Cur.y);
	int x=p->Pos2Address(m_Cur.x,true,GetFont());

	if( x==p->len )
	{
		CKEditLine* nxt = p->GetNext();
		if( nxt!=NULL )
		{
			u->buf[0] = '\r';
			u->buf[1] = '\n';

			p->InsertStr( x,nxt->buf,nxt->len,GetFont() );
			p->m_pNext = nxt->m_pNext;
			if( nxt->m_pNext!=NULL )
				nxt->m_pNext->m_pPrev=p;
			delete nxt;

			m_TxtSize.cy--;
			if( m_TxtSize.cx<p->m_Width )
				m_TxtSize.cx=p->m_Width;

			SetScrollSize(false);
			ReDrawAfter(m_Cur);
		}
		else
			bNoChange = true;
	}
	else
	{
		bool bShouldCalc = false;
		if( p->m_Width==m_TxtSize.cx )	bShouldCalc = true;

		u->buf[0] = p->buf[x];
		if( IsLead(p->buf[x]) )
		{
			u->buf[1] = p->buf[x+1];
			p->Remove(x,x+2,GetFont());
		}
		else
		{
			u->len = 1;
			p->Remove(x,x+1,GetFont());
		}

		SetScrollSize(bShouldCalc);
		ReDrawLine(m_Cur);
	}

/**/m_bLocked=false;

	if( !bNoChange )
		SendMessage(m_hParent,KEM_CHANGED,0,0);

	return bNoChange?NULL:u;
}

CUnReDo* CKEdit::BackSpace()
{
	if( GetSelByte()!=0 )
		return DeleteSel();

	if( m_Cur.x!=0 || m_Cur.y!=0 )
	{
		Move(-1,0,false,false);
		return Del();
	}
	return NULL;
}

CUnReDo* CKEdit::InputStr( const char* pStr , int l )
{
	AddUndo( DeleteSel() );

	POINT from = m_Cur;

/**/while( m_bLocked );m_bLocked=true;

	CKEditLine* p = GetBuffer(m_Cur.y);
	int x=p->Pos2Address(m_Cur.x,true,GetFont());

	int s=0;
	int y=0;
	for( int i=0; i<l; i++ )
	{
		if( pStr[i]!='\r' && pStr[i]!='\n' )
			continue;

		CKEditLine* p2 = new CKEditLine;
		p2->InsertStr(0,&p->buf[x],p->len-x,GetFont());
		p->InsertAfter(p2);

		m_TxtSize.cy++;

		p->InsertStr( x,&pStr[s],i-s,GetFont() );
		p->len=x+i-s;
		p->CalcWidth(GetFont());
		if( p->m_Width > m_TxtSize.cx )	m_TxtSize.cx = p->m_Width;
		p=p2;

		if( pStr[i]=='\r' && pStr[i+1]=='\n' )
			i++;
		s=i+1;

		y++;
		x=0;
	}

	if( s<l )
	{
		p->InsertStr( x,&pStr[s],i-s,GetFont() );
		if( p->m_Width > m_TxtSize.cx )	m_TxtSize.cx = p->m_Width;
	}
	SetScrollSize(false);
	MoveTo(p->Address2Pos( x+l-s,GetFont() ),m_Cur.y+y,false,false);
/**/m_bLocked=false;

	if( y!=0 )	ReDrawAfter( from );
	else		ReDrawLine( from );

	SendMessage(m_hParent,KEM_CHANGED,0,0);

	CUnReDo* u = new CUnReDo;
	u->m_bInput = false;
	u->m_Cur = from;
	u->m_Sel = m_Cur;
	return u;
}

void CKEdit::AddUndo( CUnReDo* u )
{
	if( u==NULL )
		return;

	CUnReDo *d=m_pRedo,*d2;
	while( d!=NULL )
	{
		d2 = d->m_pNext;
		delete d;
		d = d2;
	}

	u->m_pNext = m_pUndo;
	m_pUndo = u;
	m_pRedo = NULL;
}

bool CKEdit::FindNext( CKFind* pFinder )
{
	POINT pos = m_Cur;
	if( m_Sel.y>m_Cur.y || (m_Sel.y==m_Cur.y && m_Sel.x>m_Cur.x) )
		pos=m_Sel;

	CKEditLine *p = GetBuffer(pos.y);
	int ans,y=pos.y,xad=p->Pos2Address(pos.x,false,m_pFont);

	if( -1!=(ans=pFinder->Find(p->buf+xad, p->len-xad)) )
	{
		MoveTo( p->Address2Pos(xad+ans,m_pFont),y,false,false );
		MoveTo( p->Address2Pos(xad+ans+pFinder->MLen(),m_pFont),y,false,true );
		return true;
	}

	while( p=p->GetNext() )
	{
		y++;
		if( -1!=(ans=pFinder->Find(p->buf, p->len)) )
		{
			MoveTo( p->Address2Pos(ans,m_pFont),y,false,false );
			MoveTo( p->Address2Pos(ans+pFinder->MLen(),m_pFont),y,false,true );
			return true;
		}
	}
	return false;
}














